/*
Roman Yu. Toropov
Keyboard one wire
scheme - ac:key_adc

*/
// LCD module connections
#include <built_in.h>

sbit LCD_RS at PORTC4_bit;
sbit LCD_EN at PORTC5_bit;
sbit LCD_D4 at PORTC0_bit;
sbit LCD_D5 at PORTC1_bit;
sbit LCD_D6 at PORTC2_bit;
sbit LCD_D7 at PORTC3_bit;

sbit LCD_RS_Direction at DDC4_bit;
sbit LCD_EN_Direction at DDC5_bit;
sbit LCD_D4_Direction at DDC0_bit;
sbit LCD_D5_Direction at DDC1_bit;
sbit LCD_D6_Direction at DDC2_bit;
sbit LCD_D7_Direction at DDC3_bit;
// End LCD module connections
unsigned int adc_rd, adc_rr, adc_r, keys;


void keyb() {
       Delay_ms(50);
       ADMUX = 64; // 64 = Port F0,  ADMUX +1=F1, +2 = F2,  . .
       ADCSRA = 128+64+7;
       adc_rd = ADCL;
       adc_rr = ADCH;
       adc_r = adc_rd + 256*adc_rr;
       keys = 0;
       if ((adc_r > 450)&&(adc_r < 650)) { keys = 1; }   //"Select"
       if ((adc_r > 300)&&(adc_r < 450)) { keys = 2; }     //"left"
       if ((adc_r > 200)&&(adc_r < 300)) { keys = 3; }     //"Down"
       if ((adc_r > 50)&&(adc_r < 150)) { keys = 4; }        // "Up"
       if (adc_r < 50) { keys = 5; }                      //"Right"
       Delay_ms(50);
}

void main() {
       Lcd_Init();                        // Initialize LCD
       Lcd_Cmd(_LCD_CLEAR);               // Clear display
       Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
       ADCSRA = 128+7;
       keys=0;
     while(1){
     keyb();
     if (keys==1) {Lcd_Out(1,1,"Select");}
     if (keys==2) {Lcd_Out(1,1,"left  ");}
     if (keys==3) {Lcd_Out(1,1,"Down  ");}
     if (keys==4) {Lcd_Out(1,1,"Up    ");}
     if (keys==5) {Lcd_Out(1,1,"Right ");}

     }


}